ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.22 by root, Thu Apr 5 13:50:49 2007 UTC vs.
Revision 1.85 by root, Fri May 14 22:56:47 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
25use Storable; $Storable::canonical = 1; 54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
26 59
27sub usage { 60sub usage {
28 warn <<EOF; 61 warn <<EOF;
29Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
30 [--install-arch path] 63 [--install-arch path]
41my $VERBOSE = 1; 74my $VERBOSE = 1;
42my $CACHE = 0; 75my $CACHE = 0;
43my $FORCE; 76my $FORCE;
44my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
45my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
46 96
47END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
48 98
49Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
50Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
51 123
52mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
53 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
54 126
55sub fork_sub(&) { 127sub fork_sub(&) {
68} 140}
69 141
70sub inst_maps($) { 142sub inst_maps($) {
71 my (undef, $path) = @_; 143 my (undef, $path) = @_;
72 144
73 print "installing '$path' to '$DATADIR/maps'\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
74 146
75 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
76 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
77 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
78 } 150 }
79 151
80 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
81 and die "map installation failed.\n"; 156 and die "map installation failed.\n";
82 157
83 print "maps installed successfully.\n"; 158 print "maps installed successfully.\n";
84} 159}
85 160
86{ 161{
162 our %ANIMINFO;
87 our %FACEINFO; 163 our %FACEINFO;
164 our %RESOURCE;
88 our @ARC; 165 our @ARC;
166 our %ARC;
89 our $TRS; 167 our $TRS;
90 our $NFILE; 168 our $NFILE;
91 our %ANIM; 169 our $PATH;
92 170
93 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 171 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
94 172
95 our (@png, @trs, @arc); # files we are interested in 173 our $c_arc = new Coro::Channel;
174 our $c_trs = new Coro::Channel;
175 our $c_res = new Coro::Channel;
176
177 our @c_png;
96 178
97 sub commit_png($$$) { 179 sub commit_png($$$) {
98 my ($name, $data, $T) = @_; 180 my ($name, $data, $T) = @_;
99 181
100 $FACEINFO{$name}{"data$T"} = $data; 182 $FACEINFO{$name}{"data$T"} = $data;
101 } 183 }
102 184
103 sub process_png { 185 sub process_png {
104 while (@png) { 186 while (@c_png) {
105 my ($path, $delete) = @{pop @png}; 187 my ($path, $delete) = @{pop @c_png};
106 188
107 my $png; 189 my $png;
108 aio_lstat $path; 190 aio_lstat $path;
109 my ($size, $mtime) = (stat _)[7,9]; 191 my ($size, $mtime) = (stat _)[7,9];
110 192
141 if ($w % $T || $h % $T) { 223 if ($w % $T || $h % $T) {
142 warn "$path: weird png size ($w $h), skipping.\n"; 224 warn "$path: weird png size ($w $h), skipping.\n";
143 next; 225 next;
144 } 226 }
145 227
228 (my $base = $stem) =~ s/^.*\///;
229
230 my $fi = $FACEINFO{$base};
231 unless ($fi) {
232 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
233 #next;
234 }
235
236 my $arc = $fi->{arc} || { };
237
146 unless ($path =~ /~$/) { 238 unless ($path =~ /~$/) {
147 # possibly enlarge 239 # possibly enlarge
148 if (0 > aio_stat "$stem.64x64.png") { 240 if (0 > aio_stat "$stem.64x64.png") {
149 my $other = "$stem.64x64.png~"; 241 my $other = "$stem.64x64.png~";
150 242
151 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 243 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
152 my $wrap = 0; # for the time being
153 fork_sub { 244 fork_sub {
245 my $CROP;
246 my $SRC = "png:\Q$path\E";
247
248 my $is_floor = $arc->{is_floor};
249 my $is_wall = 0;
250
251 my ($wall_pfx, $wall_dir, $wall_sfx);
252
253 if (
254 !$is_floor
255 && !$arc->{alive}
256 && $arc->{move_block} eq "all"
257 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
258 ) {
259 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
260
261 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
262 $is_wall = 1;
263 }
264 }
265
266 if ($is_wall || $is_floor) {
267 # add a 4px border and add other images around it
268 $CROP = "-shave 8x8 +repage";
269
270 $w += 8;
271 $h += 8;
272
273 $SRC = "-size ${w}x${h} xc:transparent";
274 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
275
276 # 8 surrounding images
277 for (
278 # x y b r0 r1
279 [-1, -1, 0, 6],
280 [ 0, -1, 1, 10, 14],
281 [+1, -1, 0, 12],
282
283 [-1, 0, 8, 5, 7],
284 #
285 [+1, 0, 2, 5, 13],
286
287 [-1, +1, 0, 3],
288 [ 0, +1, 4, 10, 11],
289 [+1, +1, 0, 9],
290 ) {
291 my ($x, $y, $d, $r0, $r1) = @$_;
292
293 my $tile = $is_floor ? $path
294 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
295 : die;
296
297 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
298 "\Q$tile",
299 $x * ($w - 8) + 4,
300 $y * ($h - 8) + 4;
301 }
302 }
303
154 system "convert png:\Q$path\E -depth 8 rgba:-" 304 system "convert -depth 8 $SRC rgba:-"
155 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 305 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
156 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 306 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
157 and die "convert/hq2xa pipeline error: status $? ($!)"; 307 and die "convert/cfhq2xa pipeline error: status $? ($!)";
158 system $OPTIPNG, "-o5", "-i0", "-q", "$other~"; 308 system $OPTIPNG, "-i0", "-q", "$other~";
159 die "$other~ has zero size, aborting." unless -s "$other~"; 309 die "$other~ has zero size, aborting." unless -s "$other~";
160 rename "$other~", $other; 310 rename "$other~", $other;
161 }; 311 };
162 } 312 }
163 313
164 push @png, [$other, !$CACHE]; 314 push @c_png, [$other, !$CACHE];
165 } 315 }
166 316
167 # possibly scale down 317 # possibly scale down
168 if (0 > aio_stat "$stem.32x32.png") { 318 if (0 > aio_stat "$stem.32x32.png") {
169 my $other = "$stem.32x32.png~"; 319 my $other = "$stem.32x32.png~";
170 320
171 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 321 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
172 fork_sub { 322 fork_sub {
173 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~"; 323 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
174 system $OPTIPNG, "-o5", "-i0", "-q", "$other~"; 324 system $OPTIPNG, "-i0", "-q", "$other~";
325
326 # reduce smoothfaces >10000 bytes
327 # obsolete, no longer required
328 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
329 my $ncolor = 256;
330 while () {
331 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
332 system $OPTIPNG, "-i0", "-q", "$other~~";
333 last if 10000 > -s "$other~~";
334 $ncolor = int $ncolor * 0.9;
335 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
336 }
337
338 printf "reduced %s from %d to %d bytes using %d colours.\n",
339 $other, -s "$other~", -s "$other~~", $ncolor
340 if $VERBOSE >= 2;
341 rename "$other~~", "$other~";
342 }
343
175 die "$other~ has zero size, aborting." unless -s "$other~"; 344 die "$other~ has zero size, aborting." unless -s "$other~";
176 rename "$other~", $other; 345 rename "$other~", $other;
177 }; 346 };
178 } 347 }
179 348
180 #warn "scaled down $path to $other\n";#d# 349 #warn "scaled down $path to $other\n";#d#
181 push @png, [$other, !$CACHE]; 350 push @c_png, [$other, !$CACHE];
182 } 351 }
183 } 352 }
184 353
185 (my $face = $stem) =~ s/^.*\///; 354 (my $face = $stem) =~ s/^.*\///;
186 355
356 # split all bigfaces, but avoid smoothfaces (*_S)
187 if (($w > $T || $h > $T) && $face !~ /_S\./) { 357 if (($w > $T || $h > $T) && $face !~ /_S\./) {
188 # split 358 # split
189 my @tile; 359 my @tile;
190 for my $x (0 .. (int $w / $T) - 1) { 360 for my $x (0 .. (int $w / $T) - 1) {
191 for my $y (0 .. (int $h / $T) - 1) { 361 for my $y (0 .. (int $h / $T) - 1) {
246 aio_unlink $path if $delete; 416 aio_unlink $path if $delete;
247 } 417 }
248 } 418 }
249 419
250 sub process_arc { 420 sub process_arc {
251 while (@arc) { 421 while (my $job = $c_arc->get) {
252 my ($dir, $file) = @{pop @arc}; 422 my ($dir, $file) = @$job;
253 423
254 my $arc; 424 my $arc;
255 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 425 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
256 426
257 my $arc = read_arch "$dir/$file"; 427 my $arc = read_arch "$dir/$file";
258 for my $o (values %$arc) { 428 for my $o (values %$arc) {
259 push @ARC, $o; 429 push @ARC, $o;
430 for (my $m = $o; $m; $m = $m->{more}) {
431 $ARC{$m->{_name}} = $m;
432 }
260 433
261 $o->{editor_folder} = $dir; 434 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
262 435
263 my $visibility = delete $o->{visibility}; 436 my $visibility = delete $o->{visibility};
264 my $magicmap = delete $o->{magicmap}; 437 my $magicmap = delete $o->{magicmap};
265 438
266 # find upper left corner :/ 439 # find upper left corner :/
275 my $x = $o->{x} - $dx; 448 my $x = $o->{x} - $dx;
276 my $y = $o->{y} - $dy; 449 my $y = $o->{y} - $dy;
277 450
278 my $ext = $x|$y ? "+$x+$y" : ""; 451 my $ext = $x|$y ? "+$x+$y" : "";
279 452
280 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 453 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
281 454
282 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 455 $visibility = delete $o->{visibility} if exists $o->{visibility};
283 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 456 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
284 457
285 my $anim = delete $o->{anim}; 458 my $anim = delete $o->{anim};
286 459
287 if ($anim) { 460 if ($anim) {
461 # possibly add $ext to the animation name to avoid
462 # the need to specify archnames for all parts
463 # of a multipart archetype.
288 $o->{animation} = "$o->{_name}"; 464 $o->{animation} = "$o->{_name}";
465 my $facings = 1;
466 my @frames;
289 467
290 for (@$anim) { 468 for (@$anim) {
291 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 469 if (/^facings\s+(\d+)/) {
470 $facings = $1*1;
471 } elsif (/^blank.x11$|^empty.x11$/) {
472 push @frames, $_;
473 } else {
474 push @frames, "$_$ext";
475 }
292 } 476 }
293 477
294 $ANIM{"$o->{_name}$ext"} = 478 $ANIMINFO{$o->{animation}} = {
295 join "", map "$_\n", 479 facings => $facings,
296 "anim $o->{_name}", 480 frames => \@frames,
297 @$anim,
298 "mina";
299 } 481 };
482 }
300 483
301 for my $face ($o->{face} || (), @{$anim || []}) { 484 for ($o->{face} || (), @{$anim || []}) {
302 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 485 next if /^facings\s/;
303 486
487 my $face = $_;
488 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
489
304 my $info = $FACEINFO{$face} ||= {}; 490 my $info = $FACEINFO{$face} ||= { };
491 $info->{arc} = $o;
492
493 next if $face =~ /^blank.x11$|^empty.x11$/;
305 494
306 $info->{visibility} = $visibility if defined $visibility; 495 $info->{visibility} = $visibility if defined $visibility;
307 $info->{magicmap} = $magicmap if defined $magicmap; 496 $info->{magicmap} = $magicmap if defined $magicmap;
308 } 497 }
309 498
310 if (my $smooth = delete $o->{smoothface}) { 499 if (my $smooth = delete $o->{smoothface}) {
311 my ($face, $smooth) = split /\s+/, $smooth; 500 my %kv = split /\s+/, $smooth;
312 # skip empty_S.x11, it seems to server no purpose whatsoever 501 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
313 # but increases bandwidth demands and worse. 502 while (my ($face, $smooth) = each %kv) {
314 unless ($smooth eq "empty_S.x11") { 503 $FACEINFO{$smooth}{arc} = $o;
504
315 $FACEINFO{$face}{smooth} = $smooth; 505 $FACEINFO{$face}{smooth} = $smooth;
506 $FACEINFO{$face}{smoothlevel} = $level;
316 } 507 }
317 } 508 }
318 } 509 }
319 } 510 }
320 } 511 }
321 } 512 }
322 513
323 sub process_trs { 514 sub process_trs {
324 while (@trs) { 515 while (my $job = $c_trs->get) {
325 my ($dir, $file) = @{pop @trs}; 516 my ($dir, $file) = @$job;
326 my $path = "$dir/$file"; 517 my $path = "$dir/$file";
327 518
328 my $trs; 519 my $trs;
329 if (0 > aio_load $path, $trs) { 520 if (0 > aio_load $path, $trs) {
330 warn "$path: $!, skipping.\n"; 521 warn "$path: $!, skipping.\n";
333 524
334 $TRS .= $trs; 525 $TRS .= $trs;
335 } 526 }
336 } 527 }
337 528
529 my %FILECACHE;
530
531 sub load_cached($;$) {
532 unless (exists $FILECACHE{$_[0]}) {
533 my $data;
534 if (0 < aio_load $_[0], $data) {
535 if ($_[1]) {
536 $data = eval { $_[1]->($data) };
537 warn "$_[0]: $@" if $@;
538 }
539 }
540
541 $FILECACHE{$_[0]} = $data;
542 }
543
544 $FILECACHE{$_[0]}
545 }
546
547 sub process_res {
548 while (my $job = $c_res->get) {
549 my ($dir, $file, $type) = @$job;
550
551 my $data;
552 aio_load "$dir/$file", $data;
553
554 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
555
556 utf8::decode $dir;
557 utf8::decode $file;
558
559 # a meta file for resources is now mandatory
560 unless (exists $meta->{$file}) {
561 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
562 next;
563 }
564
565 $meta = {
566 %{ $meta->{"" } || {} },
567 %{ $meta->{$file} || {} },
568 };
569
570 if ($meta->{license} =~ s/^#//) {
571 $meta->{license} = ({
572 "pd" => "Public Domain",
573 "gpl" => "GNU General Public License, version 3.0 or any later",
574 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
575 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
576 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
577 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
578 })->{$meta->{license}}
579 || warn "$dir/$file: license tag '$meta->{license}' not found.";
580 }
581
582 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
583 ($meta->{author} = $1) =~ s/_/ /g;
584 }
585
586 $file =~ s/\.res$//;
587 $file =~ s/\.(ogg|wav|jpg|png)$//;
588
589 substr $dir, 0, 1 + length $PATH, "";
590
591 if (my $filter = $meta->{cfutil_filter}) {
592 if ($filter eq "yaml2json") {
593 $data = JSON::XS::encode_json YAML::XS::Load $data;
594 } elsif ($filter eq "json2json") {
595 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
596 } elsif ($filter eq "perl2json") {
597 $data = eval $data; die if $@;
598 $data = JSON::XS::encode_json $data;
599 } else {
600 warn "$dir/$file: unknown filter $filter, skipping\n";
601 }
602 }
603
604 $RESOURCE{"$dir/$file"} = {
605 type => (exists $meta->{type} ? delete $meta->{type} : $type),
606 data => $data,
607 %$meta ? (meta => $meta) : (),
608 };
609 }
610 }
611
338 sub find_files; 612 sub find_files;
339 sub find_files { 613 sub find_files {
340 my ($path) = @_; 614 my ($path) = @_;
341 615
342 IO::AIO::aioreq_pri 4; 616 IO::AIO::aioreq_pri 4;
343 IO::AIO::aio_scandir $path, 4, sub { 617 IO::AIO::aio_scandir $path, 4, sub {
344 my ($dirs, $nondirs) = @_; 618 my ($dirs, $nondirs) = @_;
345 619
346 find_files "$path/$_" 620 find_files "$path/$_"
347 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 621 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
622
623 my $dir = $path;
624 substr $dir, 0, 1 + length $PATH, "";
348 625
349 for my $file (@$nondirs) { 626 for my $file (@$nondirs) {
627 if ($dir =~ /^music(?:\/|$)/) {
628 $c_res->put ([$path, $file, 3]) # FT_MUSIC
629 if $file =~ /\.(ogg)$/;
630
631 } elsif ($dir =~ /^sound(?:\/|$)/) {
632 $c_res->put ([$path, $file, 5]) # FT_SOUND
633 if $file =~ /\.(wav|ogg)$/;
634
635 } elsif ($dir =~ /^res(?:\/|$)/) {
636 if ($file =~ /\.(jpg|png)$/) {
637 $c_res->put ([$path, $file, 0]) # FT_FACE
638 } elsif ($file =~ /\.(res)$/) {
639 $c_res->put ([$path, $file, 6]) # FT_RSRC
640 } else {
641 $c_res->put ([$path, $file, undef]);
642 }
643
350 if ($file =~ /\.png$/) { 644 } elsif ($file =~ /\.png$/) {
351 push @png, ["$path/$file", 0]; 645 push @c_png, ["$path/$file", 0];
646
352 } elsif ($file =~ /\.trs$/) { 647 } elsif ($file =~ /\.trs$/) {
353 push @trs, [$path, $file]; 648 $c_trs->put ([$path, $file]);
649
354 } elsif ($file =~ /\.arc$/) { 650 } elsif ($file =~ /\.arc$/) {
355 push @arc, [$path, $file]; 651 $c_arc->put ([$path, $file]);
652
356 } else { 653 } else {
357 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 654 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
358 } 655 }
359 } 656 }
360 }; 657 };
658 }
659
660 sub generate_plurals {
661# use Lingua::EN::Inflect ();
662# Lingua::EN::Inflect::classical;
663# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
664# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
665#
666# for my $a (@ARC) {
667# my $name = $a->{name} || $a->{_name};
668#
669# next unless $a->{name_pl};
670# next if $a->{invisible};
671# next if $a->{is_floor};
672# next if $a->{no_pick};
673#
674# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
675# my $pl = $test =~ /^(?:eq|p:.)$/
676# ? $name
677# : Lingua::EN::Inflect::PL $name;
678#
679# if ($pl ne $a->{name_pl}) {
680# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
681# }
682# }
361 } 683 }
362 684
363 sub inst_arch($) { 685 sub inst_arch($) {
364 my (undef, $path) = @_; 686 my (undef, $path) = @_;
365 687
688 $PATH = $path;
689
690 print "\n",
366 print "installing '$path' to '$DATADIR'\n", 691 "Installing '$path' to '$DATADIR'\n",
692 "\n",
367 "(this can take a long time if you run this\n", 693 "This can take a long time if you run this\n",
368 "for the first time or do not use --cache).\n"; 694 "for the first time or do not use --cache.\n",
695 "\n",
696 "Unless you run verbosely, all following warning\n",
697 "or error messages indicate serious problems.\n",
698 "\n";
369 699
370 if (!-d "$path/treasures") { 700 if (!-d "$path/treasures") {
371 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 701 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
372 exit 1 unless $FORCE; 702 exit 1 unless $FORCE;
373 } 703 }
374 704
705 print "scanning files...\n" if $VERBOSE;
706
375 find_files $path; 707 find_files $path;
708
709 my @a_arc = map +(async \&process_arc), 1..2;
710 my @a_res = map +(async \&process_res), 1..2;
711 my @a_trs = map +(async \&process_trs), 1..2;
712
376 IO::AIO::flush; 713 IO::AIO::flush;
377 714
378 $_->join for ( 715 $c_res->shutdown;
716 $c_arc->shutdown;
717 $c_trs->shutdown;
718
719 print "start file scan, arc, res processing...\n" if $VERBOSE;
720
721 $_->join for @a_arc; # need to parse all archetypes before png processing
722
723 print "end arc, start png processing...\n" if $VERBOSE;
724
379 # four png crunchers work fine for my 2x smp machine 725 # eight png crunchers work fine for my 4x smp machine
380 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 726 my @a_png = map +(async \&process_png), 1..8;
381 (async \&process_trs), (async \&process_trs),
382 (async \&process_arc), (async \&process_arc),
383 );
384 727
728 $_->join for (@a_trs, @a_res, @a_png);
729
730 print "scanning done, processing results...\n" if $VERBOSE;
385 { 731 {
386 open my $fh, ">:utf8", "$DATADIR/animations~" 732 # remove path prefix from editor_folder
387 or die "$DATADIR/animations~: $!"; 733 $_->{editor_folder} =~ /^\x00/
388 print $fh join "", map $ANIM{$_}, sort keys %ANIM 734 and substr $_->{editor_folder}, 0, 2 + length $path, ""
735 for values %ARC;
736
737 print "resolving inheritance tree...\n" if $VERBOSE;
738 # resolve inherit
739 while () {
740 my $progress;
741 my $loop;
742
743 for my $o (values %ARC) {
744 for my $other (split /,/, $o->{inherit}) {
745 if (my $s = $ARC{$other}) {
746 if ($s->{inherit}) {
747 $loop = $s;
748 } else {
749 delete $o->{inherit};
750 my %s = %$s;
751 delete @s{qw(_name more name name_pl)};
752 %$o = ( %s, %$o );
753 ++$progress;
754 }
755 } else {
756 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
757 delete $ARC{$o->{_name}};
758 }
759 }
760 }
761
762 unless ($progress) {
763 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
764 if $loop;
765
766 last;
767 }
389 } 768 }
390 769
391 { 770 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
771 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
772
773 print "generating plurals...\n" if $VERBOSE;
774 generate_plurals;
775
776 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
392 open my $fh, ">:utf8", "$DATADIR/archetypes~" 777 open my $fh, ">:utf8", "$DATADIR/archetypes~"
393 or die "$DATADIR/archetypes~: $!"; 778 or die "$DATADIR/archetypes~: $!";
394 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 779 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
395 print $fh Crossfire::archlist_to_string \@ARC;
396 } 780 }
397 781
398 { 782 {
783 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
399 open my $fh, ">:utf8", "$DATADIR/treasures~" 784 open my $fh, ">:utf8", "$DATADIR/treasures~"
400 or die "$DATADIR/treasures~: $!"; 785 or die "$DATADIR/treasures~: $!";
401 print $fh $TRS; 786 print $fh $TRS;
402 } 787 }
403 788
404 { 789 {
790 print "processing facedata...\n" if $VERBOSE;
405 while (my ($k, $v) = each %FACEINFO) { 791 while (my ($k, $v) = each %FACEINFO) {
406 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 792 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
407 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n"; 793 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
408 794
795 make_hash $k, $v->{data32}, $v->{hash32};
796 make_hash $k, $v->{data64}, $v->{hash64};
797
409 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n"; 798 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
410 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n"; 799 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
411 800
412 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 801 if (my $magicmap = $v->{magicmap}) {
413 $v->{chksum64} = Digest::MD5::md5 $v->{data64}; 802 $magicmap =~ y/A-Z_\-/a-z/d;
803 $v->{magicmap} = $COLOR{$magicmap};
414 } 804 }
805
806 delete $v->{arc};
807 }
808
809 print "processing resources...\n" if $VERBOSE;
810 my $enc = JSON::XS->new->utf8->canonical->relaxed;
811 while (my ($k, $v) = each %RESOURCE) {
812
813 if ($v->{meta} && $v->{meta}{datadir}) {
814 delete $RESOURCE{$k};
815
816 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
817
818 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
819 open my $fh, ">:raw", "$DATADIR/$k~"
820 or die "$DATADIR/$k~: $!";
821 syswrite $fh, $v->{data};
822 push @COMMIT, $k;
823
824 } else {
825 if ($v->{type} & 1) {
826 # prepend meta info
827
828 my $meta = $enc->encode ({
829 name => $k,
830 %{ $v->{meta} || {} },
831 });
832
833 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
834 }
835
836 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
837 }
838 }
839
840 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
841 scalar keys %FACEINFO,
842 scalar keys %ANIMINFO,
843 scalar keys %RESOURCE
844 if $VERBOSE;
415 845
416 open my $fh, ">:perlio", "$DATADIR/facedata~" 846 open my $fh, ">:perlio", "$DATADIR/facedata~"
417 or die "$DATADIR/facedata~: $!"; 847 or die "$DATADIR/facedata~: $!";
418 848
419 $FACEINFO{""} = { version => 1}; 849 print $fh nfreeze {
420 print $fh Storable::nfreeze \%FACEINFO; 850 version => 2,
851 faceinfo => \%FACEINFO,
852 animinfo => \%ANIMINFO,
853 resource => \%RESOURCE,
421 } 854 };
422 855
856 }
857
858 print "committing files...\n" if $VERBOSE;
859
423 for (qw(archetypes facedata animations treasures)) { 860 for (qw(archetypes facedata treasures), @COMMIT) {
424 chmod 0644, "$DATADIR/$_~"; 861 chmod 0644, "$DATADIR/$_~";
425 rename "$DATADIR/$_~", "$DATADIR/$_" 862 rename "$DATADIR/$_~", "$DATADIR/$_"
426 or die "$DATADIR/$_: $!"; 863 or die "$DATADIR/$_: $!";
427 } 864 }
428 865

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines